#Aggregate loss 95th percentile

#This script uses A LOT of memory (18.8 GB on my computer), it will
#probably slow your computer down significantly for a while, and may
#crash it.

#Simulate losses
U<-runif(1000000000)
paret<-4300*((1-U)^(-0.4)-1)
dim(paret)<-c(10000000,100)

#Simulate no. of losses
U<-runif(1000000000)
expon<-log(1-U)
dim(expon)<-c(10000000,100)
lambda<-rep(1,10000000)%*%t((12:111)*log(2.6))
expon<--log(1-U)
expon<-expon/lambda
exponSum<-apply(expon,1,cumsum)

#calculate aggregate losses
agg<-rowSums(paret*(t(exponSum)<1))

#delete unnecessary variables to save space
rm(U)
rm(expon)
rm(exponSum)
rm(paret)

#Calculate percentile
rnf<-rep(0,2000)
for(i in 1:2000){
rnf[i]<-quantile(agg[1:(5000*i)],0.95)
}

#Count number of observations between pi_0.95 and (pi_0.95)+100
N<-rep(0,2000)
for(i in 1:2000){
N[i]<-sum(agg[which(agg[1:(5000*i)]>rnf[i])]<(rnf[i]+100))
}

pdf("SampleSizePercentile.pdf")
plot((1:2000)*5000,N/sqrt(5000*(1:2000)),type='l',xlab="n",ylab="N/sqrt(n)")
abline(h=0.4271721)
dev.off()

size<-(min(which(N/sqrt(5000*(1:2000))>0.4271721)))*5000

pdf("SampleSizePercentileEst.pdf")
plot(5000*(1:2000),rnf,type='l',xlab="n",ylab="percentile estimate")
abline(v=size)
dev.off()

#Calculate value of $N$ for which percentile is close enough (Only
#one-sided, other side should also work.
print(size)
