#estimates the p-value of the test statistic for the Anderson-Darling test.
library(stats4)

U<-runif(1860000)
X<-qgamma(U,3.7,scale=1352)

dim(X)<-c(10000,186)

negll<-function(al,th){
    return(186*al*log(th)+sum(X[i,])/th+186*log(gamma(al))-(al-1)*sum(log(X[i,])))
}


#Estimate parameter values
st<-list(al=3.7,th=1352)    #starting values

ests<-rep(0,20000)
dim(ests)<-c(10000,2)

for(i in 1:10000){
    loop=0
    while(loop==0){
        loop=1
        tryCatch({ests[i,]<-attr(mle(negll,st),"coef")},error=function(e){
                 UU<-runif(186)
                 X[i,]<-qgamma(UU,3.7,scale=1352)
                 loop=0})
        if(ests[i,1]<1.5){#bad estimate
            UU<-runif(186)
            X[i,]<-qgamma(UU,3.7,scale=1352)
            loop=0
        }
    }
}

#calculate Anderson-Darling test statistics

AD<-rep(0,10000)
for(i in 1:10000){
    X[i,]<-sort(X[i,])
    AD[i]<-186*(sum((1-(1:185)/186)^2*(log(1-pgamma(X[i,1:185],ests[i,1],scale=ests[i,2]))-log(1-pgamma(X[i,2:186],ests[i,1],scale=ests[i,2]))))+sum(((1:186)/186)^2*(log(c(pgamma(X[i,2:186],ests[i,1],scale=ests[i,2]),1))-log(pgamma(X[i,],ests[i,1],scale=ests[i,2]))))-log(1-pgamma(X[i,1],ests[i,1],scale=ests[i,2]))-1)
}

sum(AD>1.84)
